<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ page import="org.wso2.carbon.registry.ui.relations.clients.RelationServiceClient" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.registry.ui.relations.beans.xsd.DependenciesBean" %>
<%@ page import="org.wso2.carbon.registry.ui.relations.core.xsd.Association" %>
<%@ page import="org.wso2.carbon.registry.ui.common.utils.UIUtil" %>

<script type="text/javascript" src="../registry_common/js/registry_validation.js"></script>
<script type="text/javascript" src="../registry_common/js/registry_common.js"></script>
<script type="text/javascript" src="js/prototype.js"></script>
<script type="text/javascript" src="js/relations.js"></script>

<fmt:bundle basename="org.wso2.carbon.registry.ui.relations.i18n.Resources">
<%
    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    RelationServiceClient client = new RelationServiceClient(cookie, config, session);
    DependenciesBean bean;
    try {
        if (request.getParameter("todo") != null) {
            client.addAssociation(request);
        }
        bean = client.getDependencies(request);
    } catch (Exception e) {
        response.setStatus(500);
        CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
        session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
    <jsp:include page="../admin/error.jsp?<%=e.getMessage()%>"/>
<%
        return;
    }

    String type = request.getParameter("type");
    Association[] depList = bean.getAssociations();
    Association[] assoList = bean.getAssociations();

    int count = 0;

    boolean hasAssociations = false;
    boolean hasDependencies = false;

    for (int i = 0; i < depList.length; i++) {
        Association association = depList[i];
        if (association.getSourcePath().equals(bean.getPathWithVersion()) && association.getAssociationType().equals("depends"))
            hasDependencies = true;
        if (association.getSourcePath().equals(bean.getPathWithVersion()) && !association.getAssociationType().equals("depends"))
            hasAssociations = true;
    }

    if (type.equals("depends")) {
        count = 0;
        for (int i = 0; i < depList.length; i++) {
            Association association = depList[i];
            if (association.getSourcePath().equals(bean.getPathWithVersion()) && association.getAssociationType().equals("depends")) {
                count++;
            }
        }
%>
<div id="dependenciesSum" class="summeryStyle">
    <% if (count > 1) { %>
    <%=count%> dependencies
    <%
    } else if (count == 1) {
    %>
    <%=count%> dependency
    <%
    } else if (count == 0) {
    %>
    No dependencies on this entry yet.
    <%
        }
        count = 0;
    %>
</div>

<div id="dependenciesList">
    <% if (hasDependencies == true) { %>
    <table cellpadding="0" cellspacing="0" border="0" style="width:100%;" class="styledLeft">
        <thead>
            <tr>
                <th align="left">
                    <fmt:message key="path"/>
                </th>
                <% if (bean.getLoggedIn() && bean.getPutAllowed() && !bean.getVersionView()) { %>
                <th style="width:90px;">
                    <fmt:message key="actions"/>
                </th>
                <% } %>
            </tr>
        </thead>
        <tbody>

            <%
                for (int i = 0; i < depList.length; i++) {
                    Association association = depList[i];
                    if (association.getSourcePath().equals(bean.getPathWithVersion()) && association.getAssociationType().equals("depends")) {
                        count++;
            %>
            <tr>
                <td>
                    <% String destPath = association.getDestinationPath();
                        String destLink = destPath;
                        if (!destPath.startsWith("http://")) {
                            destLink = UIUtil.getContextRoot(request) + "carbon/resources/resource.jsp?path=" + destPath;
                        }
                        String destPathSmall = destPath;
                        if (destPath.length() >= 14) {
                            destPathSmall = destPath.substring(0, 10) + "..";
                        }
                    %>
                    <a href="<%=destLink%>" title="<%=destPath%>"><%=destPathSmall%>
                    </a>
                </td>
                <% if (bean.getLoggedIn() && bean.getPutAllowed() && !bean.getVersionView()) { %>
                <td style="width:10px;" align="left">
                    <a class="icon-link" style="background-image:url(../admin/images/delete.gif);"
                       onclick="removeAssociation('<%=bean.getPathWithVersion()%>','<%=destPath%>','<%=association.getAssociationType()%>','dependenciesDiv');">
                        <fmt:message key="delete"/>
                    </a>
                </td>
                <% } %>
            </tr>

            <%
                    }
                }


            %>
            <tr>
                    <%--This empty td is required to solve the bottom margin problem on IE. Do not remove!!--%>
                <td align="left" colspan="2" style="height:0px;border-bottom:0px;">
                </td>
            </tr>
        </tbody>
    </table>

    <div style="height:30px;">
        <a class="icon-link"
           style="background-image:url(../relations/images/dep-tree.gif);padding-left:30px;height:30px;margin-top:5px;"
           onclick="showAssociationTree('depends', '<%=bean.getPathWithVersion()%>')">
            <fmt:message key="dependency.tree"/>
        </a>
    </div>
</div>
<% } %>
</div>
<% }


    if (!type.equals("depends")) {
        count = 0;

        for (int i = 0; i < assoList.length; i++) {
            Association association = assoList[i];
            if (association.getSourcePath().equals(bean.getPathWithVersion()) && !association.getAssociationType().equals("depends")) {
                count++;
            }
        }
%>
<div id="associationsSum" class="summeryStyle">
    <% if (count > 1) { %>
    <%=count%> associations
    <%
    } else if (count == 1) {
    %>
    <%=count%> association
    <%
    } else if (count == 0) {
    %>
    No associations on this entry yet.
    <%
        }
        count = 0;
    %>
</div>
<div id="associationsList">
    <% if (hasAssociations == true) { %>
    <table cellpadding="0" cellspacing="0" border="0" style="width:100%;" class="styledLeft">
        <thead>
            <tr>
                <th align="left">
                    <fmt:message key="path"/>
                </th>
                <th align="left">
                    <fmt:message key="type"/>
                </th>
                <% if (bean.getLoggedIn() && bean.getPutAllowed() && !bean.getVersionView()) { %>
                <th align="left" style="width:90px;">
                    <fmt:message key="actions"/>
                </th>
                <% } %>
            </tr>
        </thead>
        <tbody>
            <%
                for (int i = 0; i < assoList.length; i++) {
                    Association association = assoList[i];
                    if (association.getSourcePath().equals(bean.getPathWithVersion()) && !association.getAssociationType().equals("depends")) {
                        count++;
            %>
            <tr>
                <td>
                    <% String destPath = association.getDestinationPath();
                        String destLink = destPath;
                        if (!destPath.startsWith("http://")) {
                            destLink = UIUtil.getContextRoot(request) + "carbon/resources/resource.jsp?path=" + destPath;
                        }
                        String destPathSmall = destPath;
                        if (destPath.length() >= 14) {
                            destPathSmall = destPath.substring(0, 10) + "..";
                        }
                    %>
                    <a href="<%=destLink%>" title="<%=destPath%>"><%=destPathSmall%>
                    </a>
                </td>
                <td>
                    <%=association.getAssociationType()%>
                </td>
                <% if (bean.getLoggedIn() && bean.getPutAllowed() && !bean.getVersionView()) { %>
                <td style="width:10px;">
                    <a class="icon-link" style="background-image:url(../admin/images/delete.gif);"
                       onclick="removeAssociation('<%=bean.getPathWithVersion()%>','<%=destPath%>','<%=association.getAssociationType()%>','associationsDiv');">
                        <fmt:message key="delete"/>
                    </a>
                </td>
                <% } %>
            </tr>
            <%
                    }
                }


            %>
            <tr>
                    <%--This empty td is required to solve the bottom margin problem on IE. Do not remove!!--%>
                <td align="left" colspan="3" style="height:0px;border-bottom:0px;">
                </td>
            </tr>
        </tbody>
    </table>

    <div style="height:30px;">
        <a class="icon-link"
           style="background-image:url(../relations/images/asso-tree.gif);padding-left:30px;height:30px;margin-top:5px;"
           onclick="showAssociationTree('asso', '<%=bean.getPathWithVersion()%>')">
            <fmt:message key="association.tree"/></a>
    </div>
    <% } %>
</div>

<% } %>


</fmt:bundle>
